﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using DlhSoft.Windows.Data;

namespace GanttChartTaskListViewDataBindingSample
{
    /// <summary>
    /// Interaction logic for Window1.xaml
    /// </summary>
    public partial class Window1 : Window
    {
        public Window1()
        {
            InitializeComponent();

            // Prepare the task data collection.
            ObservableCollection<TaskItem> taskItems = new ObservableCollection<TaskItem>
            {
                new TaskItem { Content = "Task 1", IndexString = "1" },
                new TaskItem { Content = "Task 1.1", Indentation = 1, Start = DateTime.Today, Effort = TimeSpan.Parse("08:00:00"), CompletedEffort = TimeSpan.Parse("04:00:00"), IndexString = "2" },
                new TaskItem { Content = "Task 1.2", Indentation = 1, IndexString = "3" },
                new TaskItem { Content = "Task 1.2.1", Indentation = 2, Start = DateTime.Today, Effort = TimeSpan.Parse("08:00:00"), IndexString = "4" },
                new TaskItem { Content = "Task 1.2.2", Indentation = 2, Start = DateTime.Today, Effort = TimeSpan.Parse("16:00:00"), IndexString = "5" },
                new TaskItem { Content = "Task 2", IsExpanded = true, IndexString = "6" },
                new TaskItem { Content = "Task 2.1", Indentation = 1, Start = DateTime.Today, Effort = TimeSpan.Parse("16:00:00"), IsCompleted = true, IndexString = "7" },
                new TaskItem { Content = "Task 2.2", Indentation = 1, Start = DateTime.Today, Effort = TimeSpan.Parse("08:00:00"), CompletedEffort = TimeSpan.Parse("06:00:00"), IndexString = "8" },
                new TaskItem { Content = "Task 2.3", Indentation = 1, IsExpanded = true, IndexString = "9", PredecessorsString = "8" },
                new TaskItem { Content = "Task 2.3.1", Indentation = 2, Start = DateTime.Today, Effort = TimeSpan.Parse("1.16:00:00"), IndexString = "10", Cost = 2000 },
                new TaskItem { Content = "Task 2.3.2", Indentation = 2, Start = DateTime.Today, Effort = TimeSpan.Parse("08:00:00"), IndexString = "11", PredecessorsString = "10" },
                new TaskItem { Content = "Task 3", Start = DateTime.Today, Effort = TimeSpan.Parse("12:30:00"), CompletedEffort = TimeSpan.Parse("02:30:00"), IndexString = "12", PredecessorsString = "9, 11SS+12" },
                new TaskItem { Content = "Task 4", Start = DateTime.Today, Effort = TimeSpan.Parse("16:00:00"), AssignmentsString = "Resource 1", IndexString = "13" },
                new TaskItem { Content = "Task 5", Start = DateTime.Today, Effort = TimeSpan.Parse("20:00:00"), AssignmentsString = "Resource 1, Resource 2 [50%]", IndexString = "14" },
                new TaskItem { Content = "Task 6", Start = DateTime.Today, IsMilestone = true, IndexString = "15", PredecessorsString = "14+2" }
            };

            // You can also prepare task data items dynamically.
            for (int i = 7; i <= 64; i++)
                taskItems.Add(new TaskItem { Content = "Task " + i, Start = DateTime.Today, Effort = TimeSpan.Parse("08:00:00") });

            // Prepare the assignable resource data collection.
            ObservableCollection<ResourceItem> assignableResourceItems = new ObservableCollection<ResourceItem>
            {
                new ResourceItem { Content = "Resource 1", CostPerUsage = 100, CostPerHour = 10 },
                new ResourceItem { Content = "Resource 2", CostPerHour = 20 }
            };

            // You can also prepare assignable resource data items dynamically.
            for (int i = 3; i <= 16; i++)
                assignableResourceItems.Add(new ResourceItem { Content = "Resource " + i });

            // Set the AssignableResourceItemsSource to the prepared assignable resource data collection.
            GanttChartTaskListView.AssignableResourceItemsSource = assignableResourceItems;
            // Set the ItemsSource to the prepared task data collection.
            GanttChartTaskListView.ItemsSource = taskItems;
        }
    }
}
